<?php
/**
* Classe que manipula e gerencia toda a parte de anexos.
*
* @package    ExpressoMail
* @license    http://www.gnu.org/copyleft/gpl.html GPL
* @author     Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
* @author     Cristiano Correa
*/

class attachment
{
    /*
     * Globals variables
     */
    var $mbox;
    var $imap_port;
    var $has_cid;
    var $imap_options;
    var $imap_sentfolder;
    var $msgNumber;
    var $folder;
    var $structure;
    var $decodeConf;
    //------------------------------------------//

    /**
     * Constructor
	 * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
     * @param string $folder Imap folder name
     * @param integer $msgNumber Imap menssagem number
     */
    function attachment($rootPath = false)
    {
        /*
         * Requires
         */
        if($rootPath)
        {
            require_once $rootPath.'/library/mime/mimePart.php';
            require_once $rootPath.'/library/mime/mimeDecode.php';
        }
        else
        {
            require_once $_SESSION['rootPath'].'/library/mime/mimePart.php';
            require_once $_SESSION['rootPath'].'/library/mime/mimeDecode.php';
        }
        //----------------------------------------------------------//

        $this->decodeConf['include_bodies'] = true;
        $this->decodeConf['decode_bodies']  = true;
        $this->decodeConf['decode_headers'] = true;
    }
    //----------------------------------------------------------------------------//



    /**
     * Open mail from Imap and parse structure
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @return string  menssagem
     */
    public function setStructureFromMail($folder,$msgNumber)
    {
        $this->folder       = mb_convert_encoding($folder, 'UTF7-IMAP',mb_detect_encoding($folder.'x', 'UTF-8, ISO-8859-1'));
        $this->msgNumber    = $msgNumber;
        $this->username     = $_SESSION['phpgw_info']['expressomail']['user']['userid'];
        $this->password     = $_SESSION['phpgw_info']['expressomail']['user']['passwd'];
        $this->imap_server  = $_SESSION['phpgw_info']['expressomail']['email_server']['imapServer'];
        $this->imap_port    = $_SESSION['phpgw_info']['expressomail']['email_server']['imapPort'];
        $this->imap_delimiter = $_SESSION['phpgw_info']['expressomail']['email_server']['imapDelimiter'];
        $this->imap_sentfolder = $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder']   ? $_SESSION['phpgw_info']['expressomail']['email_server']['imapDefaultSentFolder']   : str_replace("*","", $this->functions->getLang("Sent"));
        $this->has_cid = false;

        if ($_SESSION['phpgw_info']['expressomail']['email_server']['imapTLSEncryption'] == 'yes')
            $this->imap_options = '/tls/novalidate-cert';
        else
            $this->imap_options = '/notls/novalidate-cert';

	$this->mbox = @imap_open("{".$this->imap_server.":".$this->imap_port.$this->imap_options."}".$this->folder , $this->username, $this->password) or die('Error');

        $rawMessageData = $this->_getRaw();
        $decoder = new Mail_mimeDecode($rawMessageData);
        $this->structure = $decoder->decode($this->decodeConf);

        /*
         * Clean memory and close imap connection
         */
        $rawMessageData = null;
        $decoder = null;
        @imap_close($this->mbox);
        //-----------------------------------------//
    }

    /**
     * Set Stucture from Mail_mimeDecode Structure
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @param Mail_mimeDecode $structure
     */
    public function setStructure($structure)
    {
          $this->structure = $structure;
    }

    /**
     *  Set Stucture from raw mail code
	 * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
     * @param Mail_mimeDecode $structure
     */
    public function setStructureFromRawMail($rawMail)
    {
        $decoder = new Mail_mimeDecode($rawMail);
        $this->structure = $decoder->decode($this->decodeConf);
    }

    /**
     * Returns Attachment Decoded
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @param string $partNumber Index part
     * @return string Attachment Decoded
     */
    public function getAttachment($partNumber)
    {
       $partContent = '';
       $this->_getPartContent($this->structure, $partNumber, $partContent);
       return $partContent;
    }

     /**
     * Returns EmbeddedImages Infos
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @return array EmbeddedImages
     */
    public function getEmbeddedImagesInfo()
    {
        $imagesEmbedded = array();
        $this->_getEmbeddedImagesInfo($this->structure,$imagesEmbedded);
        return $imagesEmbedded;
    }

    /**
     * Returns Attachments Infos
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @return array
     */
    public function getAttachmentsInfo()
    {
        $attachments = array();
        $this->_getAttachmentsInfo($this->structure,$attachments);
        return $attachments;
    }

    /**
     * Returns Attachment Info
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @param string $partNumber Index part
     * @return array
     */
    public function getAttachmentInfo($partNumber)
    {
        $attachment = array();
        $this->_getPartInfo($this->structure,$partNumber,$attachment);
        return $attachment;
    }

    /**
     * returns the source code menssagem
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @return string  menssagem
     */
    private function _getRaw()
    {
        return imap_fetchheader($this->mbox, $this->msgNumber, FT_UID).imap_body($this->mbox, $this->msgNumber, FT_UID);
    }

    /**
     * Returns content from the searched
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
	 * @param pointer $structure Structure object
     * @param string $soughtIndex
     * @param pointer $body Content
     * @param string $pIndex
     */
    private function _getPartContent(&$structure, $soughtIndex,&$body,$pIndex = '0')
    {
        if($structure->parts)
        {
            foreach ($structure->parts  as $index => $part)
            {
                if(strtolower($part->ctype_primary) == 'multipart')
                        $this->_getPartContent($part,$soughtIndex,$body,$pIndex.'.'.$index);
                else
                {
                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
                            $this->_getPartContent($part,$soughtIndex,$body,$pIndex.'.'.$index);
                    else
                    {
                        $currentIndex = $pIndex.'.'.$index;
                        if($currentIndex == $soughtIndex)
                        {
                            $body = $part->body;
                            break;
                        }
                    }
                }
            }
        }
        else if($soughtIndex == '0')
           $body = $structure->body;
    }

	/**
     * @license   http://www.gnu.org/copyleft/gpl.html GPL
	 * @author    Consrcio Expresso Livre - 4Linux (www.4linux.com.br) e Prognus Software Livre (www.prognus.com.br)
     */
    private function _getPartInfo(&$structure, $soughtIndex,&$info,$pIndex = '0')
    {

        if($structure->parts)
        {
            foreach ($structure->parts  as $index => $part)
            {
                if(strtolower($part->ctype_primary) == 'multipart')
                    $this->_getPartInfo($part,$soughtIndex,$info,$pIndex.'.'.$index);
                else
                {
                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
                         $this->_getPartInfo($part,$soughtIndex,$info,$pIndex.'.'.$index);
                    else
                    {
                        $currentIndex = $pIndex.'.'.$index;
                        if($currentIndex == $soughtIndex)
                        {
                            $info['pid'] = $currentIndex;
                            $info['name'] = $part->d_parameters['filename'];
                            $info['encoding'] = $part->headers['content-transfer-encoding'];
                            $info['fsize'] = mb_strlen($part->body, $part->headers['content-transfer-encoding']);
                            break;
                        }
                    }
                }
            }
        }else if($soughtIndex == '0')
        {
            $info['pid'] = '0';
            $info['name'] = $structure->d_parameters['filename'];
            $info['encoding'] = $structure->headers['content-transfer-encoding'];
            $info['fsize'] = mb_strlen($structure->body, $structure->headers['content-transfer-encoding']);
        }
    }



     /**
     * Write in $attachments, array with the information of attachments
     * @param <type> $structure
     * @param <type> $attachments
     */
    private function _getAttachmentsInfo($structure, &$attachments, $pIndex = '0')
    {

        if($structure->parts)
        {
            foreach ($structure->parts  as $index => $part)
            {
                if(strtolower($part->ctype_primary) == 'multipart')
                    $this->_getAttachmentsInfo($part,$attachments,$pIndex.'.'.$index);
                else
                {
                    if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
                       $this->_getAttachmentsInfo($part,$attachments,$pIndex.'.'.$index);
                    else
                    {
                        if(!$part->headers['content-transfer-encoding']) //Caso no esteja especificado a codificao 
 		                    $part->headers['content-transfer-encoding'] = mb_detect_encoding ($part->body,array('BASE64','Quoted-Printable','7bit','8bit','ASCII')); 
 		                if($part->headers['content-transfer-encoding'] === FALSE) //Caso a tentativa de achar a codificao retorne FALSE 
							$part->headers['content-transfer-encoding'] = 'binary'; 
						if($part->headers['content-transfer-encoding'] === 'ASCII') //Caso a codificao retorne ascii especifica como base64 
							$part->headers['content-transfer-encoding'] = 'base64';
						
						if($part->d_parameters['filename'])
                        {
                            $definition['pid'] = $pIndex.'.'.$index;
                            $definition['name'] = $part->d_parameters['filename'];
                            $definition['encoding'] = $part->headers['content-transfer-encoding'];
                            $definition['fsize'] = mb_strlen($part->body, $part->headers['content-transfer-encoding']);

                            array_push($attachments, $definition);
                        }
                        else if($part->ctype_parameters['name'])
                        {
                            $definition['pid'] = $pIndex.'.'.$index;
                            $definition['name'] = $part->ctype_parameters['name'];
                            $definition['encoding'] = $part->headers['content-transfer-encoding'];
                            $definition['fsize'] = mb_strlen($part->body, $part->headers['content-transfer-encoding']);

                            array_push($attachments, $definition);
                        }
                        else if(strtolower($part->ctype_primary) == 'text' &&  strtolower($part->ctype_secondary) == 'calendar')
                        {
                            $definition['pid'] = $pIndex.'.'.$index;
                            $definition['name'] = 'calendar.ics';
                            $definition['encoding'] = $part->headers['content-transfer-encoding'];
                            $definition['fsize'] = mb_strlen($part->body, $part->headers['content-transfer-encoding']);

                            array_push($attachments, $definition);
                        }
                     
                    }
                }
            }
        }
        else
        {
            if($structure->d_parameters['filename'])
            {
                $definition['pid'] = '0';
                $definition['name'] = $structure->d_parameters['filename'];
                $definition['encoding'] = $structure->headers['content-transfer-encoding'];
                $definition['fsize'] = mb_strlen($structure->body, $structure->headers['content-transfer-encoding']);

                array_push($attachments, $definition);
            }
            else if($structure->ctype_parameters['name'])
            {
                $definition['pid'] = '0';
                $definition['name'] = $structure->ctype_parameters['name'];
                $definition['encoding'] = $structure->headers['content-transfer-encoding'];
                $definition['fsize'] = mb_strlen($structure->body, $structure->headers['content-transfer-encoding']);

                array_push($attachments, $definition);
            }
            else if(strtolower($structure->ctype_primary) == 'text' &&  strtolower($structure->ctype_secondary) == 'calendar')
            {
                $definition['pid'] = '0';
                $definition['name'] = 'calendar.ics';
                $definition['encoding'] = $structure->headers['content-transfer-encoding'];
                $definition['fsize'] = mb_strlen($structure->body, $structure->headers['content-transfer-encoding']);

                array_push($attachments, $definition);
             }
        }

    }

    /**
     * Write in $images, array with the information of Embedded Images
     * @param <type> $structure
     * @param <type> $attachments
     */
     private function _getEmbeddedImagesInfo($structure, &$images, $pIndex = '0')
     {
        foreach ($structure->parts  as $index => $part)
        {
            if(strtolower($part->ctype_primary) == 'multipart')
                    $this->_getEmbeddedImagesInfo($part,$images,$pIndex.'.'.$index);
            else
            {
                if(strtolower($part->ctype_primary) == 'message' && is_array($part->parts))
                        $this->_getEmbeddedImagesInfo($part,$images,$pIndex.'.'.$index);
                else
                {
                    if(!$part->ctype_parameters['name'])
                         $name = $part->d_parameters['filename'];
                    else
                         $name = $part->ctype_parameters['name'];

                    $type =  strtolower(substr($name, -4));
                    $ctype = strtolower($part->ctype_primary.'/'.$part->ctype_secondary);
                    if(strtolower($part->ctype_primary) == 'image' ||  ($ctype == 'application/octet-stream' && ($type == '.png' || $type == '.jpg' || $type == '.gif')))
                    {
                        $definition['pid'] = $pIndex.'.'.$index;
                        $definition['name'] = $name;
                        $definition['type'] = 'image/'.strtolower($part->ctype_secondary);
                        $definition['encoding'] = $part->headers['content-transfer-encoding'];
                        $definition['cid'] = $part->headers['content-id'];
                        array_push($images, $definition);
                    }
                }
            }
        }
    }

}

?>
